@use "sass:map";

@import '../../styles/variables';
@import '../../styles/mixins';

.cui-alert {
  display: flex;
  overflow: hidden;
  position: relative;
  border-radius: $cui-alert-border-radius;
  background-color: $cui-alert-background-base;
  @include cui-break-word();

  &::after {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    opacity: $cui-alert-background-opacity;
  }

  &[data-cui-mode='secondary']::after,
  &[data-cui-mode='ghost']::after {
    opacity: 1;
  }

  &[data-cui-mode='ghost'] {
    box-shadow: inset 0 0 0 2px cui-color(ghost, bg-active);
  }

  .alert-icon,
  .alert-close,
  .alert-body {
    z-index: 1;
    position: relative;
  }

  // ----- modes

  @mixin mode($mode) {
    &[data-cui-mode='#{$mode}'] {
      &::after {
        background-color: cui-color($mode, bg);
      }
      .alert-icon {
        color: cui-color($mode, text);
      }
    }
  }

  @include mode('primary');
  @include mode('secondary');
  @include mode('ghost');
  @include mode('note');
  @include mode('info');
  @include mode('success');
  @include mode('warning');
  @include mode('error');

  // ----- sizes

  @mixin size($size, $padding: map.get($cui-alert-padding, $size)) {
    &[data-cui-size='#{$size}'] {
      padding: $padding;

      .alert-icon {
        margin-right: $padding * 0.5;
      }
      .alert-close {
        margin: -0.375rem -0.375rem -0.375rem $padding * 0.5;
      }
    }
  }

  @include size('s');
  @include size('m');
  @include size('l');
}
